#pragma once


namespace Eldec_Example {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace EldecInterface;

	public ref class Form1 : public System::Windows::Forms::Form
	{

	private: System::Windows::Forms::GroupBox^  groupBox4;
	private: System::Windows::Forms::Label^  labelUSBID2;
	private: System::Windows::Forms::TextBox^  textUSBID2;
	private: System::Windows::Forms::CheckBox^  checkBoxUSBID2;
	private: System::Windows::Forms::ListBox^  listBoxInfo2;
	private: System::Windows::Forms::Button^  buttonGetExternalInput;
	private: System::Windows::Forms::Button^  buttonGetWriteValue;

	EldecDevice ^ eldecDevice;
	private: System::Windows::Forms::Button^  buttonDeviceOFF;

	private: System::Windows::Forms::Button^  buttonDeviceON;
	private: System::Windows::Forms::Button^  buttonDeviceRestart;
	private: System::Windows::Forms::GroupBox^  groupBox5;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::TextBox^  textContrast;

	private: System::Windows::Forms::Button^  buttonSetContrast;



			 EldecDevice ^ eldecDevice2;

	public:
		Form1(void)
		{
			InitializeComponent();

			eldecDevice = gcnew EldecDevice();
			eldecDevice2 = gcnew EldecDevice();
			Form1::Text =  "ELDEC Interface " + eldecDevice->GetInterfaceVersion() + " - Example";
		}

	protected:

		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	protected: 
	private: System::Windows::Forms::ListBox^  listBoxInfo;

	private: System::Windows::Forms::GroupBox^  groupBox1;
	private: System::Windows::Forms::TextBox^  textMainValue;
	private: System::Windows::Forms::Button^  buttonSetMainValue;
	private: System::Windows::Forms::CheckBox^  checkBoxSetMainValue;



	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::GroupBox^  groupBox2;
	private: System::Windows::Forms::Label^  labelUSBID;

	private: System::Windows::Forms::TextBox^  textUSBID;


	private: System::Windows::Forms::Button^  buttonConnect;
	private: System::Windows::Forms::GroupBox^  groupBox3;
	private: System::Windows::Forms::Button^  buttonGetTemperature;
	private: System::Windows::Forms::Button^  buttonDisableProtect;
	private: System::Windows::Forms::Button^  buttonEnableProtect;


	private: System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code

		void InitializeComponent(void)
		{
			this->listBoxInfo = (gcnew System::Windows::Forms::ListBox());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->buttonGetWriteValue = (gcnew System::Windows::Forms::Button());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->checkBoxSetMainValue = (gcnew System::Windows::Forms::CheckBox());
			this->textMainValue = (gcnew System::Windows::Forms::TextBox());
			this->buttonSetMainValue = (gcnew System::Windows::Forms::Button());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->groupBox4 = (gcnew System::Windows::Forms::GroupBox());
			this->checkBoxUSBID2 = (gcnew System::Windows::Forms::CheckBox());
			this->labelUSBID2 = (gcnew System::Windows::Forms::Label());
			this->textUSBID2 = (gcnew System::Windows::Forms::TextBox());
			this->labelUSBID = (gcnew System::Windows::Forms::Label());
			this->textUSBID = (gcnew System::Windows::Forms::TextBox());
			this->buttonConnect = (gcnew System::Windows::Forms::Button());
			this->groupBox3 = (gcnew System::Windows::Forms::GroupBox());
			this->buttonDeviceRestart = (gcnew System::Windows::Forms::Button());
			this->buttonDeviceOFF = (gcnew System::Windows::Forms::Button());
			this->buttonDeviceON = (gcnew System::Windows::Forms::Button());
			this->buttonGetExternalInput = (gcnew System::Windows::Forms::Button());
			this->buttonGetTemperature = (gcnew System::Windows::Forms::Button());
			this->buttonDisableProtect = (gcnew System::Windows::Forms::Button());
			this->buttonEnableProtect = (gcnew System::Windows::Forms::Button());
			this->listBoxInfo2 = (gcnew System::Windows::Forms::ListBox());
			this->groupBox5 = (gcnew System::Windows::Forms::GroupBox());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->textContrast = (gcnew System::Windows::Forms::TextBox());
			this->buttonSetContrast = (gcnew System::Windows::Forms::Button());
			this->groupBox1->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->groupBox4->SuspendLayout();
			this->groupBox3->SuspendLayout();
			this->groupBox5->SuspendLayout();
			this->SuspendLayout();
			// 
			// listBoxInfo
			// 
			this->listBoxInfo->FormattingEnabled = true;
			this->listBoxInfo->Location = System::Drawing::Point(10, 280);
			this->listBoxInfo->Name = L"listBoxInfo";
			this->listBoxInfo->Size = System::Drawing::Size(110, 277);
			this->listBoxInfo->TabIndex = 1;
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->buttonGetWriteValue);
			this->groupBox1->Controls->Add(this->label1);
			this->groupBox1->Controls->Add(this->checkBoxSetMainValue);
			this->groupBox1->Controls->Add(this->textMainValue);
			this->groupBox1->Controls->Add(this->buttonSetMainValue);
			this->groupBox1->Location = System::Drawing::Point(245, 7);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(119, 211);
			this->groupBox1->TabIndex = 5;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = L"Set Main Value";
			// 
			// buttonGetWriteValue
			// 
			this->buttonGetWriteValue->Location = System::Drawing::Point(8, 143);
			this->buttonGetWriteValue->Name = L"buttonGetWriteValue";
			this->buttonGetWriteValue->Size = System::Drawing::Size(102, 60);
			this->buttonGetWriteValue->TabIndex = 10;
			this->buttonGetWriteValue->Text = L"Get Write Value";
			this->buttonGetWriteValue->UseVisualStyleBackColor = true;
			this->buttonGetWriteValue->Click += gcnew System::EventHandler(this, &Form1::buttonGetWriteValue_Click);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(6, 48);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(37, 13);
			this->label1->TabIndex = 9;
			this->label1->Text = L"Value:";
			// 
			// checkBoxSetMainValue
			// 
			this->checkBoxSetMainValue->AutoSize = true;
			this->checkBoxSetMainValue->Location = System::Drawing::Point(9, 20);
			this->checkBoxSetMainValue->Name = L"checkBoxSetMainValue";
			this->checkBoxSetMainValue->Size = System::Drawing::Size(81, 17);
			this->checkBoxSetMainValue->TabIndex = 8;
			this->checkBoxSetMainValue->Text = L"Write Value";
			this->checkBoxSetMainValue->UseVisualStyleBackColor = true;
			// 
			// textMainValue
			// 
			this->textMainValue->Location = System::Drawing::Point(45, 45);
			this->textMainValue->Name = L"textMainValue";
			this->textMainValue->Size = System::Drawing::Size(64, 20);
			this->textMainValue->TabIndex = 5;
			this->textMainValue->Text = L"10";
			// 
			// buttonSetMainValue
			// 
			this->buttonSetMainValue->Location = System::Drawing::Point(8, 75);
			this->buttonSetMainValue->Name = L"buttonSetMainValue";
			this->buttonSetMainValue->Size = System::Drawing::Size(102, 60);
			this->buttonSetMainValue->TabIndex = 4;
			this->buttonSetMainValue->Text = L"Set Main Value";
			this->buttonSetMainValue->UseVisualStyleBackColor = true;
			this->buttonSetMainValue->Click += gcnew System::EventHandler(this, &Form1::buttonSetMainValue_Click);
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->groupBox4);
			this->groupBox2->Controls->Add(this->labelUSBID);
			this->groupBox2->Controls->Add(this->textUSBID);
			this->groupBox2->Controls->Add(this->buttonConnect);
			this->groupBox2->Location = System::Drawing::Point(10, 7);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(226, 108);
			this->groupBox2->TabIndex = 9;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"Device Connecting";
			// 
			// groupBox4
			// 
			this->groupBox4->Controls->Add(this->checkBoxUSBID2);
			this->groupBox4->Controls->Add(this->labelUSBID2);
			this->groupBox4->Controls->Add(this->textUSBID2);
			this->groupBox4->Location = System::Drawing::Point(9, 52);
			this->groupBox4->Name = L"groupBox4";
			this->groupBox4->Size = System::Drawing::Size(209, 48);
			this->groupBox4->TabIndex = 12;
			this->groupBox4->TabStop = false;
			this->groupBox4->Text = L"Second Device";
			// 
			// checkBoxUSBID2
			// 
			this->checkBoxUSBID2->AutoSize = true;
			this->checkBoxUSBID2->Location = System::Drawing::Point(129, 22);
			this->checkBoxUSBID2->Name = L"checkBoxUSBID2";
			this->checkBoxUSBID2->Size = System::Drawing::Size(59, 17);
			this->checkBoxUSBID2->TabIndex = 14;
			this->checkBoxUSBID2->Text = L"Enable";
			this->checkBoxUSBID2->UseVisualStyleBackColor = true;
			this->checkBoxUSBID2->CheckedChanged += gcnew System::EventHandler(this, &Form1::checkBoxUSBID2_CheckedChanged);
			// 
			// labelUSBID2
			// 
			this->labelUSBID2->AutoSize = true;
			this->labelUSBID2->Enabled = false;
			this->labelUSBID2->Location = System::Drawing::Point(5, 23);
			this->labelUSBID2->Name = L"labelUSBID2";
			this->labelUSBID2->Size = System::Drawing::Size(43, 13);
			this->labelUSBID2->TabIndex = 13;
			this->labelUSBID2->Text = L"USBID:";
			// 
			// textUSBID2
			// 
			this->textUSBID2->Enabled = false;
			this->textUSBID2->Location = System::Drawing::Point(50, 20);
			this->textUSBID2->Name = L"textUSBID2";
			this->textUSBID2->Size = System::Drawing::Size(50, 20);
			this->textUSBID2->TabIndex = 12;
			this->textUSBID2->Text = L"1";
			// 
			// labelUSBID
			// 
			this->labelUSBID->AutoSize = true;
			this->labelUSBID->Location = System::Drawing::Point(14, 26);
			this->labelUSBID->Name = L"labelUSBID";
			this->labelUSBID->Size = System::Drawing::Size(43, 13);
			this->labelUSBID->TabIndex = 11;
			this->labelUSBID->Text = L"USBID:";
			// 
			// textUSBID
			// 
			this->textUSBID->Location = System::Drawing::Point(59, 23);
			this->textUSBID->Name = L"textUSBID";
			this->textUSBID->Size = System::Drawing::Size(50, 20);
			this->textUSBID->TabIndex = 10;
			this->textUSBID->Text = L"0";
			// 
			// buttonConnect
			// 
			this->buttonConnect->Location = System::Drawing::Point(117, 18);
			this->buttonConnect->Name = L"buttonConnect";
			this->buttonConnect->Size = System::Drawing::Size(102, 30);
			this->buttonConnect->TabIndex = 2;
			this->buttonConnect->Text = L"Connect";
			this->buttonConnect->UseVisualStyleBackColor = true;
			this->buttonConnect->Click += gcnew System::EventHandler(this, &Form1::buttonConnect_Click);
			// 
			// groupBox3
			// 
			this->groupBox3->Controls->Add(this->buttonDeviceRestart);
			this->groupBox3->Controls->Add(this->buttonDeviceOFF);
			this->groupBox3->Controls->Add(this->buttonDeviceON);
			this->groupBox3->Controls->Add(this->buttonGetExternalInput);
			this->groupBox3->Controls->Add(this->buttonGetTemperature);
			this->groupBox3->Controls->Add(this->buttonDisableProtect);
			this->groupBox3->Controls->Add(this->buttonEnableProtect);
			this->groupBox3->Location = System::Drawing::Point(10, 118);
			this->groupBox3->Name = L"groupBox3";
			this->groupBox3->Size = System::Drawing::Size(226, 100);
			this->groupBox3->TabIndex = 10;
			this->groupBox3->TabStop = false;
			this->groupBox3->Text = L"Other Functions";
			// 
			// buttonDeviceRestart
			// 
			this->buttonDeviceRestart->Location = System::Drawing::Point(149, 71);
			this->buttonDeviceRestart->Name = L"buttonDeviceRestart";
			this->buttonDeviceRestart->Size = System::Drawing::Size(72, 22);
			this->buttonDeviceRestart->TabIndex = 16;
			this->buttonDeviceRestart->Text = L"Restart";
			this->buttonDeviceRestart->UseVisualStyleBackColor = true;
			this->buttonDeviceRestart->Click += gcnew System::EventHandler(this, &Form1::buttonDeviceRestart_Click);
			// 
			// buttonDeviceOFF
			// 
			this->buttonDeviceOFF->Location = System::Drawing::Point(149, 44);
			this->buttonDeviceOFF->Name = L"buttonDeviceOFF";
			this->buttonDeviceOFF->Size = System::Drawing::Size(72, 22);
			this->buttonDeviceOFF->TabIndex = 15;
			this->buttonDeviceOFF->Text = L"Device OFF";
			this->buttonDeviceOFF->UseVisualStyleBackColor = true;
			this->buttonDeviceOFF->Click += gcnew System::EventHandler(this, &Form1::buttonDeviceOFF_Click);
			// 
			// buttonDeviceON
			// 
			this->buttonDeviceON->Location = System::Drawing::Point(149, 17);
			this->buttonDeviceON->Name = L"buttonDeviceON";
			this->buttonDeviceON->Size = System::Drawing::Size(72, 22);
			this->buttonDeviceON->TabIndex = 14;
			this->buttonDeviceON->Text = L"Device ON";
			this->buttonDeviceON->UseVisualStyleBackColor = true;
			this->buttonDeviceON->Click += gcnew System::EventHandler(this, &Form1::buttonDeviceON_Click);
			// 
			// buttonGetExternalInput
			// 
			this->buttonGetExternalInput->Location = System::Drawing::Point(66, 57);
			this->buttonGetExternalInput->Name = L"buttonGetExternalInput";
			this->buttonGetExternalInput->Size = System::Drawing::Size(78, 36);
			this->buttonGetExternalInput->TabIndex = 13;
			this->buttonGetExternalInput->Text = L"Get Extern.Input";
			this->buttonGetExternalInput->UseVisualStyleBackColor = true;
			this->buttonGetExternalInput->Click += gcnew System::EventHandler(this, &Form1::buttonGetExternalInput_Click);
			// 
			// buttonGetTemperature
			// 
			this->buttonGetTemperature->Location = System::Drawing::Point(66, 17);
			this->buttonGetTemperature->Name = L"buttonGetTemperature";
			this->buttonGetTemperature->Size = System::Drawing::Size(78, 36);
			this->buttonGetTemperature->TabIndex = 12;
			this->buttonGetTemperature->Text = L"Get Temperature";
			this->buttonGetTemperature->UseVisualStyleBackColor = true;
			this->buttonGetTemperature->Click += gcnew System::EventHandler(this, &Form1::buttonGetTemperature_Click);
			// 
			// buttonDisableProtect
			// 
			this->buttonDisableProtect->Location = System::Drawing::Point(5, 57);
			this->buttonDisableProtect->Name = L"buttonDisableProtect";
			this->buttonDisableProtect->Size = System::Drawing::Size(56, 36);
			this->buttonDisableProtect->TabIndex = 11;
			this->buttonDisableProtect->Text = L"Disable Protect";
			this->buttonDisableProtect->UseVisualStyleBackColor = true;
			this->buttonDisableProtect->Click += gcnew System::EventHandler(this, &Form1::buttonDisableProtect_Click);
			// 
			// buttonEnableProtect
			// 
			this->buttonEnableProtect->Location = System::Drawing::Point(5, 17);
			this->buttonEnableProtect->Name = L"buttonEnableProtect";
			this->buttonEnableProtect->Size = System::Drawing::Size(56, 36);
			this->buttonEnableProtect->TabIndex = 10;
			this->buttonEnableProtect->Text = L"Enable Protect";
			this->buttonEnableProtect->UseVisualStyleBackColor = true;
			this->buttonEnableProtect->Click += gcnew System::EventHandler(this, &Form1::buttonEnableProtect_Click);
			// 
			// listBoxInfo2
			// 
			this->listBoxInfo2->FormattingEnabled = true;
			this->listBoxInfo2->Location = System::Drawing::Point(127, 280);
			this->listBoxInfo2->Name = L"listBoxInfo2";
			this->listBoxInfo2->Size = System::Drawing::Size(237, 277);
			this->listBoxInfo2->TabIndex = 11;
			// 
			// groupBox5
			// 
			this->groupBox5->Controls->Add(this->label2);
			this->groupBox5->Controls->Add(this->textContrast);
			this->groupBox5->Controls->Add(this->buttonSetContrast);
			this->groupBox5->Location = System::Drawing::Point(10, 224);
			this->groupBox5->Name = L"groupBox5";
			this->groupBox5->Size = System::Drawing::Size(226, 47);
			this->groupBox5->TabIndex = 12;
			this->groupBox5->TabStop = false;
			this->groupBox5->Text = L"Display Settings";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(7, 22);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(49, 13);
			this->label2->TabIndex = 12;
			this->label2->Text = L"Contrast:";
			// 
			// textContrast
			// 
			this->textContrast->Location = System::Drawing::Point(66, 19);
			this->textContrast->Name = L"textContrast";
			this->textContrast->Size = System::Drawing::Size(43, 20);
			this->textContrast->TabIndex = 11;
			this->textContrast->Text = L"10";
			// 
			// buttonSetContrast
			// 
			this->buttonSetContrast->Location = System::Drawing::Point(117, 18);
			this->buttonSetContrast->Name = L"buttonSetContrast";
			this->buttonSetContrast->Size = System::Drawing::Size(104, 22);
			this->buttonSetContrast->TabIndex = 10;
			this->buttonSetContrast->Text = L"Set Contrast";
			this->buttonSetContrast->UseVisualStyleBackColor = true;
			this->buttonSetContrast->Click += gcnew System::EventHandler(this, &Form1::buttonSetContrast_Click);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(374, 568);
			this->Controls->Add(this->groupBox5);
			this->Controls->Add(this->listBoxInfo2);
			this->Controls->Add(this->groupBox3);
			this->Controls->Add(this->groupBox2);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->listBoxInfo);
			this->Name = L"Form1";
			this->Text = L"ELDEC Interface X.XX - Example";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->groupBox1->ResumeLayout(false);
			this->groupBox1->PerformLayout();
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			this->groupBox4->ResumeLayout(false);
			this->groupBox4->PerformLayout();
			this->groupBox3->ResumeLayout(false);
			this->groupBox5->ResumeLayout(false);
			this->groupBox5->PerformLayout();
			this->ResumeLayout(false);

		}
#pragma endregion
	
	//***************************************************************************************
	private: System::Void buttonConnect_Click(System::Object^  sender, System::EventArgs^  e) 
	{

		bool success;
		int USBID;
		int USBID2;
		unsigned char USBFlag;

		eldecDevice->DisconnectDevice();
		eldecDevice2->DisconnectDevice();

		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");


		success=int::TryParse(textUSBID->Text,USBID);
		if(success) success=eldecDevice->ConnectDevice(USBID,&USBFlag);
		if(success)
		{
			listBoxInfo->Items->Add("Device:");
			listBoxInfo->Items->Add("DeviceLine:");
			listBoxInfo->Items->Add("DeviceName:");
			listBoxInfo->Items->Add("DeviceForm:");
			listBoxInfo->Items->Add("DeviceType:");
			listBoxInfo->Items->Add("DeviceVersion:");
			listBoxInfo->Items->Add("DeviceID:");
			listBoxInfo->Items->Add("DeviceBooting:");
			listBoxInfo->Items->Add("DeviceTime:");

			listBoxInfo2->Items->Add(" ");
			listBoxInfo2->Items->Add(eldecDevice->GetDeviceConnect());
			listBoxInfo2->Items->Add(eldecDevice->GetDeviceLine());
			listBoxInfo2->Items->Add(eldecDevice->GetDeviceName());
			listBoxInfo2->Items->Add(eldecDevice->GetDeviceForm());
			listBoxInfo2->Items->Add(eldecDevice->GetDeviceType());
			listBoxInfo2->Items->Add(eldecDevice->GetDeviceVersion());
			listBoxInfo2->Items->Add(eldecDevice->GetDeviceID());
			listBoxInfo2->Items->Add(eldecDevice->GetDeviceBooting());
			listBoxInfo2->Items->Add(eldecDevice->GetDeviceTime());
		}
		else
		{
			listBoxInfo2->Items->Add("No new device has been connected.");
			listBoxInfo->Items->Add("USBFlag:");
			listBoxInfo2->Items->Add(USBFlag.ToString());
		}


		if(checkBoxUSBID2->Checked)
		{

			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");
			listBoxInfo->Items->Add("DEVICE 2");

			success=int::TryParse(textUSBID2->Text,USBID2);
			if(success) success=eldecDevice2->ConnectDevice(USBID2,&USBFlag);
			if(success)
			{
				listBoxInfo->Items->Add("Device:");
				listBoxInfo->Items->Add("DeviceLine:");
				listBoxInfo->Items->Add("DeviceName:");
				listBoxInfo->Items->Add("DeviceForm:");
				listBoxInfo->Items->Add("DeviceType:");
				listBoxInfo->Items->Add("DeviceVersion:");
				listBoxInfo->Items->Add("DeviceID:");
				listBoxInfo->Items->Add("DeviceBooting:");
				listBoxInfo->Items->Add("DeviceTime:");

				listBoxInfo2->Items->Add(" ");
				listBoxInfo2->Items->Add(eldecDevice2->GetDeviceConnect());
				listBoxInfo2->Items->Add(eldecDevice2->GetDeviceLine());
				listBoxInfo2->Items->Add(eldecDevice2->GetDeviceName());
				listBoxInfo2->Items->Add(eldecDevice2->GetDeviceForm());
				listBoxInfo2->Items->Add(eldecDevice2->GetDeviceType());
				listBoxInfo2->Items->Add(eldecDevice2->GetDeviceVersion());
				listBoxInfo2->Items->Add(eldecDevice2->GetDeviceID());
				listBoxInfo2->Items->Add(eldecDevice2->GetDeviceBooting());
				listBoxInfo2->Items->Add(eldecDevice2->GetDeviceTime());
			}
			else
			{
				listBoxInfo2->Items->Add("No new device has been connected.");
				listBoxInfo->Items->Add("USBFlag:");
				listBoxInfo2->Items->Add(USBFlag.ToString());

			}

		}

	}

	//***************************************************************************************
	private: System::Void buttonSetMainValue_Click(System::Object^  sender, System::EventArgs^  e) 
	{
		bool success;
		int value;
		bool write;
		unsigned char protectState;

		write=checkBoxSetMainValue->Checked;

		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");

		success=int::TryParse(textMainValue->Text,value);
		if(success) success = eldecDevice->SetMainValue(value,write,&protectState);
		if(success) 
		{

			listBoxInfo2->Items->Add(" ");
			listBoxInfo->Items->Add("protectState:");
			listBoxInfo2->Items->Add(protectState.ToString());

		}
		else listBoxInfo2->Items->Add("Error has been detected.");

		if(checkBoxUSBID2->Checked)
		{
			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");
			listBoxInfo->Items->Add("DEVICE 2");

			success=int::TryParse(textMainValue->Text,value);
			if(success) success = eldecDevice2->SetMainValue(value,write,&protectState);
			if(success) 
			{
				listBoxInfo2->Items->Add(" ");
				listBoxInfo->Items->Add("protectState:");
				listBoxInfo2->Items->Add(protectState.ToString());
				listBoxInfo->Items->Add(" ");
			}
			else listBoxInfo2->Items->Add("Error has been detected.");
		}

	}

	//***************************************************************************************
	private: System::Void buttonSetContrast_Click(System::Object^  sender, System::EventArgs^  e)
	{

		bool success;
		int value;

		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");

		success=int::TryParse(textContrast->Text,value);
		if(success) success = eldecDevice->SetDisplay(value);
		if(success) 
		{

			listBoxInfo2->Items->Add(" ");
			listBoxInfo2->Items->Add("Contrast has been set.");

		}
		else listBoxInfo2->Items->Add("Error has been detected.");

		if(checkBoxUSBID2->Checked)
		{
			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");
			listBoxInfo->Items->Add("DEVICE 2");

			success=int::TryParse(textContrast->Text,value);
			if(success) success = eldecDevice2->SetDisplay(value);
			if(success) 
			{
				listBoxInfo2->Items->Add("Contrast has been set.");
			}
			else listBoxInfo2->Items->Add("Error has been detected.");
		}

	}

	//***************************************************************************************
	private: System::Void buttonGetWriteValue_Click(System::Object^  sender, System::EventArgs^  e) 
	{
		bool success;
		int value;
		bool set;
		unsigned char protectState;

		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");

		success = eldecDevice->GetWriteValue(&value,&set,&protectState);
		if(success) 
		{
			listBoxInfo2->Items->Add(" ");

			listBoxInfo->Items->Add("value:");
			listBoxInfo->Items->Add("set:");
			listBoxInfo->Items->Add("protectState:");
			listBoxInfo2->Items->Add(value.ToString());
			listBoxInfo2->Items->Add(set.ToString());
			listBoxInfo2->Items->Add(protectState.ToString());
		}
		else listBoxInfo2->Items->Add("Error has been detected.");

		if(checkBoxUSBID2->Checked)
		{

			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");
			listBoxInfo->Items->Add("DEVICE 2");

			success = eldecDevice2->GetWriteValue(&value,&set,&protectState);
			if(success) 
			{
				listBoxInfo2->Items->Add(" ");

				listBoxInfo->Items->Add("value:");
				listBoxInfo->Items->Add("set:");
				listBoxInfo->Items->Add("protectState:");
				listBoxInfo2->Items->Add(value.ToString());
				listBoxInfo2->Items->Add(set.ToString());
				listBoxInfo2->Items->Add(protectState.ToString());
			}
			else listBoxInfo2->Items->Add("Error has been detected.");

		}

	}

	//***************************************************************************************
	private: System::Void buttonGetTemperature_Click(System::Object^  sender, System::EventArgs^  e) 
	{
		int tmp1, tmp2, tmp3;

		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");

		if(eldecDevice->GetTemperature(&tmp1,&tmp2,&tmp3))
		{
			listBoxInfo2->Items->Add(" ");

			listBoxInfo->Items->Add("tmp1:");
			listBoxInfo->Items->Add("tmp2:");
			listBoxInfo->Items->Add("tmp3:");
			listBoxInfo2->Items->Add((tmp1/10).ToString() + "." + (tmp1%10).ToString() + " C");
			listBoxInfo2->Items->Add((tmp2/10).ToString() + "." + (tmp2%10).ToString() + " C");
			listBoxInfo2->Items->Add((tmp3/10).ToString() + "." + (tmp3%10).ToString() + " C");
		}
		else listBoxInfo2->Items->Add("Error has been detected.");

		if(checkBoxUSBID2->Checked)
		{
			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");

			listBoxInfo->Items->Add("DEVICE 2");

			if(eldecDevice2->GetTemperature(&tmp1,&tmp2,&tmp3))
			{
				listBoxInfo2->Items->Add(" ");

				listBoxInfo->Items->Add("tmp1:");
				listBoxInfo->Items->Add("tmp2:");
				listBoxInfo->Items->Add("tmp3:");
				listBoxInfo2->Items->Add((tmp1/10).ToString() + "." + (tmp1%10).ToString() + " C");
				listBoxInfo2->Items->Add((tmp2/10).ToString() + "." + (tmp2%10).ToString() + " C");
				listBoxInfo2->Items->Add((tmp3/10).ToString() + "." + (tmp3%10).ToString() + " C");
			}
			else listBoxInfo2->Items->Add("Error has been detected.");
		}


	}
	//***************************************************************************************
	private: System::Void buttonEnableProtect_Click(System::Object^  sender, System::EventArgs^  e) 
	{
		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");

		if(eldecDevice->EnableProtect())
		{
			listBoxInfo2->Items->Add(" ");
			listBoxInfo2->Items->Add("Protect has been enabled.");
		}
		else listBoxInfo2->Items->Add("Error has been detected.");

		if(checkBoxUSBID2->Checked)
		{

			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");

			listBoxInfo->Items->Add("DEVICE 2");

			if(eldecDevice2->EnableProtect())
			{
				listBoxInfo2->Items->Add("Protect has been enabled.");
			}
			else listBoxInfo2->Items->Add("Error has been detected.");

		}
	}
	//***************************************************************************************
	private: System::Void buttonDisableProtect_Click(System::Object^  sender, System::EventArgs^  e) 
	{
		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");

		if(eldecDevice->DisableProtect())
		{
			listBoxInfo2->Items->Add(" ");
			listBoxInfo2->Items->Add("Protect has been disabled.");
		}
		else listBoxInfo2->Items->Add("Error has been detected.");

		if(checkBoxUSBID2->Checked)
		{

			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");

			listBoxInfo->Items->Add("DEVICE 2");
			
			if(eldecDevice2->DisableProtect())
			{
				listBoxInfo2->Items->Add("Protect has been disabled.");
			}
			else listBoxInfo2->Items->Add("Error has been detected.");

		}
	}

	//***************************************************************************************
	private: System::Void buttonGetExternalInput_Click(System::Object^  sender, System::EventArgs^  e) 
	{
		bool input;

		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");

		if(eldecDevice->GetExternalInput(&input))
		{
			listBoxInfo2->Items->Add(" ");
			listBoxInfo->Items->Add("input:");
			listBoxInfo2->Items->Add(input.ToString());
		}
		else listBoxInfo2->Items->Add("Error has been detected.");

		if(checkBoxUSBID2->Checked)
		{

			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");

			listBoxInfo->Items->Add("DEVICE 2");

			if(eldecDevice2->GetExternalInput(&input))
			{
				listBoxInfo2->Items->Add(" ");
				listBoxInfo->Items->Add("input:");
				listBoxInfo2->Items->Add(input.ToString());
			}
			else listBoxInfo2->Items->Add("Error has been detected.");

		}

	}

	//***************************************************************************************
	private: System::Void checkBoxUSBID2_CheckedChanged(System::Object^  sender, System::EventArgs^  e) 
	{
			labelUSBID2->Enabled=checkBoxUSBID2->Checked;
			textUSBID2->Enabled=checkBoxUSBID2->Checked;
	}

	//***************************************************************************************
	private: System::Void buttonDeviceON_Click(System::Object^  sender, System::EventArgs^  e) 
	{

		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");

		if(eldecDevice->DeviceON())
		{
			listBoxInfo2->Items->Add(" ");
			listBoxInfo2->Items->Add("Device ON");
		}
		else listBoxInfo2->Items->Add("Error has been detected.");

		if(checkBoxUSBID2->Checked)
		{

			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");

			listBoxInfo->Items->Add("DEVICE 2");
			
			if(eldecDevice2->DeviceON())
			{
				listBoxInfo2->Items->Add("Device ON");
			}
			else listBoxInfo2->Items->Add("Error has been detected.");

		}

	}

	//***************************************************************************************
	private: System::Void buttonDeviceOFF_Click(System::Object^  sender, System::EventArgs^  e) 
	{
		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");

		if(eldecDevice->DeviceOFF())
		{
			listBoxInfo2->Items->Add(" ");
			listBoxInfo2->Items->Add("Device OFF");
		}
		else listBoxInfo2->Items->Add("Error has been detected.");

		if(checkBoxUSBID2->Checked)
		{

			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");

			listBoxInfo->Items->Add("DEVICE 2");
			
			if(eldecDevice2->DeviceOFF())
			{
				listBoxInfo2->Items->Add("Device OFF");
			}
			else listBoxInfo2->Items->Add("Error has been detected.");

		}
	}
	//***************************************************************************************
	private: System::Void buttonDeviceRestart_Click(System::Object^  sender, System::EventArgs^  e) 
	{
		listBoxInfo->Items->Clear();
		listBoxInfo2->Items->Clear();

		listBoxInfo->Items->Add("DEVICE 1");

		if(eldecDevice->DeviceRestart())
		{
			listBoxInfo2->Items->Add(" ");
			listBoxInfo2->Items->Add("Restart is running.");
			listBoxInfo2->Items->Add("The device can't communicate now.");
			listBoxInfo2->Items->Add("Reconnect the device after restart.");

			listBoxInfo->Items->Add(" ");
			listBoxInfo->Items->Add(" ");
			listBoxInfo->Items->Add(" ");

		}
		else listBoxInfo2->Items->Add("Error has been detected.");

		if(checkBoxUSBID2->Checked)
		{

			listBoxInfo->Items->Add(" ");
			listBoxInfo2->Items->Add(" ");

			listBoxInfo->Items->Add("DEVICE 2");
			
			if(eldecDevice2->DeviceRestart())
			{
				listBoxInfo2->Items->Add(" ");
				listBoxInfo2->Items->Add("Restart is running.");
				listBoxInfo2->Items->Add("The device can't communicate now.");
				listBoxInfo2->Items->Add("Reconnect the device after restart.");

				listBoxInfo->Items->Add(" ");
				listBoxInfo->Items->Add(" ");
			}
			else listBoxInfo2->Items->Add("Error has been detected.");
		}
	}
private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
		 }
};
}

